import e, { createContext as Z, useContext as O, useMemo as P, useCallback as y, useRef as z, useEffect as L, useState as $ } from "react";
import { get as R, set as x, clone as X } from "radash";
import { usePointerDrag as J } from "react-use-pointer-drag";
import ee from "@uiw/react-color-sketch";
import te from "filesize";
const B = Z(void 0);
function I({ path: r, fallbackValue: l, onChange: s, errorPath: c, error: t }) {
  const n = O(B), a = P(() => (n == null ? void 0 : n.getValue(r)) ?? l, [n, r, l]), v = y((u) => {
    r && n && n.setValue(r, u), s == null || s(u);
  }, [r, n, s]);
  return t || (t = n == null ? void 0 : n.getError(c || r)), [a, v, t];
}
const ue = ({ values: r, errors: l, updateValues: s, onChange: c, onChangeValue: t, className: n, children: a }) => {
  const v = y((o) => o ? R(r, o) : void 0, [r]), u = y((o, E) => {
    t == null || t(o, E);
    const g = x(X(r), o, E);
    s == null || s(g), c == null || c(g);
  }, [r, s, c, t]), m = y((o) => l && o ? R(l, o) : void 0, [l]), i = P(() => ({ values: r, getValue: v, setValue: u, getError: m }), [r, v, u]);
  return e.createElement(
    B.Provider,
    { value: i },
    e.createElement("div", { className: "react-var-ui " + (n ?? "") }, a)
  );
}, S = ({ label: r, children: l, className: s, disabled: c, readOnly: t, column: n = !1, error: a }) => e.createElement(
  "div",
  { className: "react-var-ui-label " + (r ? "react-var-ui-label-has-label " : "react-var-ui-label-no-label ") + (c ? "react-var-ui-disabled " : "") + (t ? "react-var-ui-read-only " : "") + (n ? "react-var-ui-label-column " : "") + (s ?? "") },
  !!r && e.createElement("span", null, r),
  l,
  a ? e.createElement("div", { className: "react-var-ui-error" }, a) : null
), T = Math.PI * 2;
function Y(r) {
  return (T + r % T) % T;
}
const se = ({ label: r, path: l, value: s, onChange: c, disabled: t, readOnly: n, defaultValue: a = 0, className: v, error: u, errorPath: m }) => {
  const i = z(null), [o, E, g] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: u,
    errorPath: m
  }), f = P(() => Math.round(Y(o) * (180 / Math.PI)), [o]), { dragProps: d } = J({
    onMove: ({ x: p, y: h }) => {
      const b = i.current.getBoundingClientRect(), C = b.left + b.width / 2, V = b.top + b.height / 2;
      E(Y(Math.atan2(h - V, p - C) + Math.PI / 2));
    }
  });
  return L(() => {
    var p;
    (p = i.current) == null || p.addEventListener("wheel", (h) => h.preventDefault());
  }, []), e.createElement(
    S,
    { label: r, disabled: t, readOnly: n, className: v, error: g },
    e.createElement(
      "span",
      { className: "react-var-ui-angle-value" },
      f,
      "°"
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-angle" },
      e.createElement("div", { className: "react-var-ui-angle-control react-var-ui-interactive", ref: i, style: { transform: `rotate(${f}deg)` }, onDoubleClick: () => typeof a < "u" && E(a), onWheel: (p) => {
        E(Y(o + 0.5 * Math.sign(p.deltaY)));
      }, title: "Angle", ...d() })
    )
  );
}, ie = ({ path: r, value: l, onChange: s, disabled: c, className: t, children: n, error: a, errorPath: v }) => {
  const [u, m, i] = I({
    path: r,
    fallbackValue: l,
    onChange: s,
    error: a,
    errorPath: v
  });
  return e.createElement("div", { className: "react-var-ui-array " + (c ? "react-var-ui-disabled " : "") + (t ?? "") }, u == null ? void 0 : u.map((o, E, g) => e.createElement(B.Provider, { value: {
    values: o,
    getValue: (f) => f ? R(o, f) : void 0,
    setValue: (f, d) => {
      const p = [...u];
      p[E] = x(X(o), f, d), m(p);
    },
    getError: (f) => {
      const d = i == null ? void 0 : i[E];
      return d && f ? R(d, f) : void 0;
    }
  }, key: E }, typeof n == "function" ? n(o, E, g) : n)));
}, me = ({ label: r, onClick: l, buttonLabel: s, disabled: c, className: t, error: n }) => e.createElement(
  S,
  { label: r, disabled: c, className: t, error: n },
  e.createElement(
    "span",
    { className: "react-var-ui-button" },
    e.createElement("button", { onClick: () => l == null ? void 0 : l(), disabled: c }, s)
  )
), ve = ({ label: r, path: l, value: s, onChange: c, alpha: t, disabled: n, readOnly: a, className: v, error: u, errorPath: m }) => {
  const [i, o, E] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: u,
    errorPath: m
  }), [g, f] = $(!1);
  return e.createElement(
    S,
    { label: r, disabled: n, readOnly: a, className: v, error: E },
    e.createElement(
      "span",
      null,
      e.createElement("span", { className: "react-var-ui-color-value" }, i),
      e.createElement(
        "div",
        { className: "react-var-ui-color react-var-ui-interactive" },
        e.createElement(
          "div",
          { className: "react-var-ui-color-swatch", onClick: () => f((d) => !d) },
          e.createElement("div", { className: "react-var-ui-color-color", title: "Color preview", style: { background: i } })
        ),
        g ? e.createElement(
          "div",
          { className: "react-var-ui-color-popover" },
          e.createElement("div", { className: "react-var-ui-color-cover", onClick: () => f(!1) }),
          e.createElement(ee, { color: i, onChange: (d) => {
            o(t ? d.hexa : d.hex);
          }, disableAlpha: !t })
        ) : null
      )
    )
  );
}, de = ({ label: r, path: l, value: s, disabled: c, readOnly: t, className: n, error: a, errorPath: v, unit: u }) => {
  const [m, i, o] = I({
    path: l,
    fallbackValue: s,
    error: a,
    errorPath: v
  });
  return e.createElement(
    S,
    { label: r, disabled: c, readOnly: t, className: n, error: o },
    e.createElement(
      "span",
      null,
      m,
      u
    )
  );
}, j = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { d: "M.5 9.9a.5.5 0 0 1 .5.5v2.5a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-2.5a.5.5 0 0 1 1 0v2.5a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2v-2.5a.5.5 0 0 1 .5-.5z" }),
  e.createElement("path", { d: "M7.646 1.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 2.707V11.5a.5.5 0 0 1-1 0V2.707L5.354 4.854a.5.5 0 1 1-.708-.708l3-3z" })
), Ee = ({ label: r, path: l, value: s, onChange: c, disabled: t, readOnly: n, className: a, accept: v, displayMetadata: u = !0, error: m, errorPath: i }) => {
  const [o, E, g] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: m,
    errorPath: i
  }), f = y((d) => {
    var h;
    if (!((h = d.target.files) != null && h.length))
      return;
    const p = d.target.files[0];
    E(p);
  }, [E]);
  return e.createElement(
    S,
    { label: r, disabled: t, readOnly: n, className: a, error: g },
    e.createElement("span", { className: "react-var-ui-file-value" }, o == null ? void 0 : o.name),
    e.createElement(
      "div",
      { className: "react-var-ui-file react-var-ui-interactive" },
      u && !!o && e.createElement(
        "div",
        { className: "react-var-ui-file-metadata" },
        e.createElement(
          "div",
          null,
          "Size: ",
          te(o.size)
        ),
        e.createElement(
          "div",
          null,
          "Type: ",
          o.type || "unknown"
        )
      ),
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: v, onChange: f, title: "File upload" })
    )
  );
}, fe = ({ label: r, path: l, value: s, onChange: c, disabled: t, readOnly: n, className: a, error: v, errorPath: u }) => {
  const [m, i, o] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: v,
    errorPath: u
  }), E = y((g) => {
    var p;
    if (!((p = g.target.files) != null && p.length))
      return;
    const f = g.target.files[0], d = URL.createObjectURL(f);
    i(d);
  }, [i]);
  return e.createElement(
    S,
    { label: r, disabled: t, readOnly: n, className: a, error: o, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-image react-var-ui-interactive" },
      e.createElement("div", { className: "react-var-ui-image-background", style: {
        backgroundImage: m ? `url('${m}')` : void 0
      }, title: "Image preview" }),
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: "image/*", onChange: E, title: "Image upload" })
    )
  );
}, ge = ({ label: r, path: l, value: s, onChange: c, disabled: t, readOnly: n, className: a, acceptImage: v, acceptAudio: u, acceptVideo: m, error: i, errorPath: o }) => {
  const [E, g, f] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: i,
    errorPath: o
  }), [d, p] = $(), h = P(() => {
    let V = "";
    return v && (V += "image/*,"), u && (V += "audio/*,"), m && (V += "video/*,"), V.endsWith(",") && (V = V.slice(0, -1)), V || (V = "image/*,audio/*,video/*"), V;
  }, [v, u, m]), w = y((V) => {
    var M;
    if (!((M = V.target.files) != null && M.length))
      return;
    const N = V.target.files[0], F = URL.createObjectURL(N);
    g(F);
  }, [g, p]), b = y(async (V) => {
    var F, M, D;
    if (!V) {
      p(void 0);
      return;
    }
    const N = await fetch(V);
    p((D = (M = (F = N == null ? void 0 : N.headers) == null ? void 0 : F.get("Content-Type")) == null ? void 0 : M.split("/")) == null ? void 0 : D[0]);
  }, [p]);
  L(() => {
    b(E);
  }, [E]);
  let C = e.createElement("div", { className: "react-var-ui-media-metadata" }, E ? "Unsupported file type." : "");
  switch (d) {
    case "image":
      C = e.createElement("div", { className: "react-var-ui-media-background", style: {
        backgroundImage: `url('${E}')`
      }, title: "Media preview" });
      break;
    case "video":
      C = e.createElement("video", { className: "react-var-ui-media-background", muted: !0, loop: !0, autoPlay: !0, src: E, title: "Media preview" });
      break;
    case "audio":
      C = e.createElement("audio", { className: "react-var-ui-media-audio", loop: !0, controls: !0, src: E, title: "Media preview" });
      break;
  }
  return e.createElement(
    S,
    { label: r, disabled: t, readOnly: n, className: a, error: f, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-media react-var-ui-interactive" },
      C,
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: h, onChange: w, title: "Media upload" })
    )
  );
};
function q(r, l, s, c, t) {
  var a;
  isFinite(r) || (r = l ?? 0);
  let n = 2;
  return typeof c == "number" && (n = ((a = c.toString().split(".")[1]) == null ? void 0 : a.length) || 0, r = Math.round(r / c) * c), typeof l == "number" && (r = Math.max(l, r)), typeof s == "number" && (r = Math.min(s, r)), t ? Math.round(r) : parseFloat(r.toFixed(n));
}
const W = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z" })
), H = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M7.646 4.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1-.708.708L8 5.707l-5.646 5.647a.5.5 0 0 1-.708-.708l6-6z" })
), G = ({ value: r, onChange: l, min: s, max: c, step: t, className: n, disabled: a, readOnly: v, round: u, unit: m }) => {
  const i = z(null), o = y((f) => {
    i.current && (i.current.value = String(u(f))), l(f);
  }, [l, u]);
  L(() => {
    i.current && (i.current.value = String(r));
  }, [r]);
  const E = () => {
    const f = i.current;
    f && o(parseFloat(f.value));
  }, g = a || v ? {} : {
    onBlur: E,
    onKeyDown: (f) => {
      const d = i.current;
      switch (f.key) {
        case "ArrowUp":
          f.preventDefault(), o(parseFloat(d.value) + t);
          break;
        case "ArrowDown":
          f.preventDefault(), o(parseFloat(d.value) - t);
          break;
      }
    },
    onKeyUp: (f) => {
      f.key === "Enter" && (f.preventDefault(), E());
    }
  };
  return e.createElement(
    "div",
    { className: n },
    e.createElement("input", { type: "number", min: s, max: c, step: t, disabled: a, readOnly: v, ref: i, ...g }),
    m ? e.createElement("span", null, m) : null
  );
}, pe = ({ label: r, path: l, value: s, onChange: c, min: t, max: n, step: a = 1, integer: v, showButtons: u, disabled: m, readOnly: i, className: o, error: E, errorPath: g, unit: f }) => {
  const [d, p, h] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: E,
    errorPath: g
  }), w = y((V) => q(V, t, n, a, !!v), [t, n, a, v]), b = P(() => w(d), [d, w]), C = y((V) => {
    V = w(V), p(V);
  }, [w, p]);
  return e.createElement(
    S,
    { label: r, disabled: m, readOnly: i, className: o, error: h },
    e.createElement(
      "div",
      { className: "react-var-ui-number" },
      e.createElement(G, { className: "react-var-ui-number-input", round: w, min: t, max: n, step: a, value: b, disabled: m, readOnly: i, onChange: C, unit: f }),
      u && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: () => C(d + a), disabled: m || i },
          e.createElement(H, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: () => C(d - a), disabled: m || i },
          e.createElement(W, null)
        )
      )
    )
  );
}, Ve = ({ path: r, value: l, onChange: s, children: c, error: t, errorPath: n }) => {
  const [a, v, u] = I({
    path: r,
    fallbackValue: l,
    onChange: s,
    error: t,
    errorPath: n
  });
  return e.createElement(B.Provider, { value: {
    values: a,
    getValue: (m) => m ? R(a, m) : void 0,
    setValue: (m, i) => {
      const o = x(X(a), m, i);
      v(o);
    },
    getError: (m) => u && m ? R(u, m) : void 0
  } }, c);
}, he = ({ label: r, path: l, value: s, onChange: c, options: t, disabled: n, readOnly: a, className: v, error: u, errorPath: m }) => {
  const [i, o, E] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: u,
    errorPath: m
  }), g = P(() => JSON.stringify(i), [i]), f = !!t.find((d) => JSON.stringify(d.value ?? d.key) === g);
  return e.createElement(
    S,
    { label: r, disabled: n, readOnly: a, className: v, error: E },
    e.createElement(
      "div",
      { className: "react-var-ui-select" },
      e.createElement(
        "select",
        { onChange: (d) => o(JSON.parse(d.target.value)), value: g, title: "Select options", disabled: n || a },
        !f && e.createElement("option", { value: g }, String(i)),
        t.map((d) => {
          const p = JSON.stringify(d.value ?? d.key);
          return e.createElement("option", { key: d.key, value: p }, d.label);
        })
      )
    )
  );
}, we = ({ label: r, path: l, value: s, onChange: c, min: t, max: n, step: a, integer: v, defaultValue: u, showInput: m, showButtons: i, disabled: o, readOnly: E, className: g, error: f, errorPath: d, unit: p }) => {
  const h = z(null), [w, b, C] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: f,
    errorPath: d
  }), V = y((k) => q(k, t, n, a, !!v), [t, n, a, v]), N = P(() => V(w), [w, V]), F = P(() => (N - t) / (n - t) * 100, [N, t, n]), M = y((k) => {
    b(V(k));
  }, [V, b]), D = y((k) => {
    const K = h.current.getBoundingClientRect(), Q = (k - K.left) / K.width;
    M(t + (n - t) * Q);
  }, [M, v, t, n, a]), { dragProps: A } = J({
    onMove: ({ x: k }) => D(k)
  });
  return L(() => {
    var k;
    (k = h.current) == null || k.addEventListener("wheel", (U) => U.preventDefault());
  }, []), e.createElement(
    S,
    { label: r, disabled: o, readOnly: E, className: g, error: C },
    e.createElement(
      "div",
      { className: "react-var-ui-slider" },
      e.createElement(
        "div",
        { className: "react-var-ui-slider-track react-var-ui-interactive", ref: h, onClick: (k) => D(k.clientX), onDoubleClick: () => typeof u < "u" && M(u), onWheel: (k) => M(w - a * Math.sign(k.deltaY)), title: "Slider", ...A() },
        e.createElement("div", { className: "react-var-ui-slider-content", style: { width: F + "%" } })
      ),
      m ? e.createElement(G, { className: "react-var-ui-slider-input", round: V, min: t, max: n, step: a, disabled: o, readOnly: E, onChange: M, value: w, unit: p }) : e.createElement(
        "span",
        null,
        N.toString(),
        p
      ),
      i && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: () => M(w + a), disabled: o || E },
          e.createElement(H, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: () => M(w - a), disabled: o || E },
          e.createElement(W, null)
        )
      )
    )
  );
}, Ne = ({ label: r, path: l, value: s, onChange: c, maxLength: t, multiline: n, autoexpand: a, disabled: v, readOnly: u, className: m, error: i, errorPath: o }) => {
  const [E, g, f] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: i,
    errorPath: o
  }), d = (h) => {
    const w = h.currentTarget;
    w.style.height = "0", w.style.height = `${w.scrollHeight}px`;
  }, p = P(() => a ? { overflow: "hidden", resize: "none" } : void 0, [a]);
  return e.createElement(S, { label: r, disabled: v, readOnly: u, className: m, column: n, error: f }, n ? e.createElement("textarea", { className: "react-var-ui-string-multiline", value: E, onChange: (h) => g(h.target.value), onInput: a ? d : void 0, style: p, disabled: v, readOnly: u }) : e.createElement(
    "span",
    { className: "react-var-ui-string" },
    e.createElement("input", { type: "text", maxLength: t, value: E, onChange: (h) => g(h.target.value), disabled: v, readOnly: u })
  ));
}, ke = ({ label: r, path: l, value: s, onChange: c, disabled: t, readOnly: n, className: a, error: v, errorPath: u }) => {
  const [m, i, o] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: v,
    errorPath: u
  });
  return e.createElement(
    S,
    { label: r, disabled: t, readOnly: n, className: a, error: o },
    e.createElement(
      "span",
      null,
      e.createElement(
        "label",
        { className: "react-var-ui-toggle", title: "Toggle" },
        e.createElement("input", { type: "checkbox", checked: m, onChange: (E) => i(E.target.checked), disabled: t, readOnly: n }),
        e.createElement("span", { className: "react-var-ui-toggle-helper" })
      )
    )
  );
};
function _(r, l, s, c) {
  var n;
  const t = [0, 0];
  if (!r || !Array.isArray(r) || r.length < 2)
    return t;
  for (let a = 0; a < c.length; a++) {
    const v = ((n = c[a].toString().split(".")[1]) == null ? void 0 : n.length) || 0;
    t[a] = Math.round(r[a] / c[a]) * c[a], t[a] = Math.max(l[a], t[a]), t[a] = Math.min(s[a], t[a]), t[a] = parseFloat(t[a].toFixed(v));
  }
  return t;
}
function re(r, l, s) {
  if (!r)
    return [50, 50];
  const c = [0, 0];
  for (let t = 0; t < r.length; t++)
    c[t] = (r[t] - l[t]) / (s[t] - l[t]) * 100;
  return c;
}
const ye = ({ label: r, path: l, value: s, onChange: c, disabled: t, readOnly: n, className: a, defaultValue: v = [0, 0], min: u = [-1, -1], max: m = [1, 1], step: i = [0.01, 0.01], error: o, errorPath: E }) => {
  const g = z(null), [f, d, p] = I({
    path: l,
    fallbackValue: s,
    onChange: c,
    error: o,
    errorPath: E
  }), h = P(() => _(f, u, m, i), [f, u, m, i]), w = P(() => re(h, u, m), [h, u, m]), b = y((N, F) => {
    if (!g.current)
      return;
    const D = g.current.getBoundingClientRect(), A = (N - D.left) / D.width, k = (F - D.top) / D.height, U = _([
      u[0] + (m[0] - u[0]) * A,
      u[1] + (m[1] - u[1]) * k
    ], u, m, i);
    d(U);
  }, [d, u, m, i]), { dragProps: C } = J({
    onMove: ({ x: N, y: F }) => b(N, F)
  }), V = y(() => {
    typeof v < "u" && d(v);
  }, [v, d]);
  return e.createElement(
    S,
    { label: r, disabled: t, readOnly: n, className: a, error: p },
    e.createElement(
      "span",
      { className: "react-var-ui-xy-value" },
      h[0],
      ", ",
      h[1]
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-xy react-var-ui-interactive" },
      e.createElement(
        "div",
        { className: "react-var-ui-xy-space", ref: g, onClick: (N) => b(N.clientX, N.clientY), onDoubleClick: V, ...C() },
        e.createElement("div", { className: "react-var-ui-xy-control", style: { top: w[1] + "%", left: w[0] + "%" } })
      )
    )
  );
}, be = ({ label: r, className: l, children: s, collapsible: c }) => {
  const [t, n] = $(!1);
  return e.createElement(
    "div",
    { className: "react-var-ui-category " + (l ?? "") },
    e.createElement(
      "div",
      { className: "react-var-ui-category-title" },
      r,
      c && e.createElement("button", { title: t ? "Expand" : "Collapse", className: "react-var-ui-category-collapse", onClick: () => n((a) => !a) }, t ? e.createElement(W, null) : e.createElement(H, null))
    ),
    (!c || !t) && e.createElement("div", null, s)
  );
};
export {
  se as VarAngle,
  ie as VarArray,
  S as VarBase,
  me as VarButton,
  be as VarCategory,
  ve as VarColor,
  de as VarDisplay,
  Ee as VarFile,
  fe as VarImage,
  ge as VarMedia,
  pe as VarNumber,
  Ve as VarScope,
  he as VarSelect,
  we as VarSlider,
  Ne as VarString,
  ke as VarToggle,
  ue as VarUI,
  ye as VarXY,
  I as useVarUIValue
};
